=== debian/control ===
Source: swift-im
Section: net
Priority: optional
Maintainer: Debian XMPP Maintainers <pkg-xmpp-devel@alioth-lists.debian.net>
Uploaders: Tobias Frost <tobi@debian.org>
Build-Depends: debhelper-compat (= 13),
               docbook-xml,
               docbook-xsl,
               help2man,
               libavahi-client-dev,
               libboost-date-time-dev,
               libboost-dev,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-regex-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libhunspell-dev,
               libidn-dev,
               libminiupnpc-dev,
               libnatpmp-dev,
               libqt5svg5-dev,
               libqt5x11extras5-dev,
               libsqlite3-dev,
               libssl-dev,
               libxml2-dev,
               libxml2-utils,
               libxss-dev,
               qt5-image-formats-plugins,
               qtbase5-dev,
               qtbase5-dev-tools,
               qtchooser,
               qtmultimedia5-dev,
               qttools5-dev-tools,
               scons,
               xsltproc,
               zlib1g-dev
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/xmpp-team/swift-im.git
Vcs-Browser: https://salsa.debian.org/xmpp-team/swift-im
Homepage: https://swift.im
Rules-Requires-Root: no

Package: libswiften0
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Multi-Arch: same
Description: XMPP library
 Swiften is a robust, high-quality, standards-compliant, cross-platform,
 and performant C++ library for implementing XMPP applications. Swiften
 is used as the back-end library for the Swift Instant Messaging client.

Package: libswiften-dev
Architecture: any
Section: libdevel
Depends: libboost-date-time-dev,
         libboost-dev,
         libboost-filesystem-dev,
         libboost-regex-dev,
         libboost-thread-dev,
         libswiften0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: XMPP library (development files)
 Swiften is a robust, high-quality, standards-compliant, cross-platform,
 and performant C++ library for implementing XMPP applications. Swiften
 is used as the back-end library for the Swift Instant Messaging client.
 .
 This package contains the header development files and programs for
 developing with Swiften.
