=== debian/watch ===
version=4
opts="mode=git,pretty=describe, \
    uversionmangle=s/swift\.//g;s/(alpha|beta|rc)/~$1/g, \
    dversionmangle=s/\+dfsg[0-9]+$//, repacksuffix=+dfsg, \
    pgpmode=none"  \
    git://swift.im/swift HEAD
